﻿using System;
using System.IO;

namespace banyato
{
  class Program
  {
    static int Hosszu;
    static int Szeles; 
    static int[,] To;

    static void Main()
    {
      Beolvas();
      Console.WriteLine("\n2. feladat");
      Console.Write("A mérés sorának azonosítója: ");
      int sor = int.Parse(Console.ReadLine());
      Console.Write("A mérés oszlopának azonosítója: ");
      int oszlop = int.Parse(Console.ReadLine());
      Console.WriteLine($"A mért mélység az adott helyen {To[sor,oszlop]} dm ");
      Console.WriteLine("\n3. feladat");
      (int t, double h) = Jellemzes();
      /*tuple C#-os verziója*/
      Console.OutputEncoding = System.Text.Encoding.UTF8;
      /*extra a ² kiírásához*/
      Console.WriteLine($"A tó felszíne: {t} m², átlagos mélysége: {h:F2} m");
      /*F2 helyett számformátummal: {h:0.00}*/
      Console.WriteLine("\n4. feladat");
      Legmelyebb();
      Console.WriteLine("\n5. feladat");
      Console.WriteLine($"A tó partvonala {Parthossz()} m hosszú");
      Console.WriteLine("\n6. feladat");
      Console.Write("A vizsgált szelvény oszlopának azonosítója: ");
      int metszet = int.Parse(Console.ReadLine());
      Diagram(metszet);
    }

    private static void Diagram(int metszet)
    {
      StreamWriter sw = new("diagram.txt");
      for (int i = 1; i <= Hosszu; i++)
      {
        sw.Write($"{i:00}");
        int db = (To[i, metszet] + 5) / 10;
        /*vagy: (int)Math.Round((decimal)To[i, metszet] / 10, MidpointRounding.AwayFromZero);*/
        for (int k = 0; k < db; k++)
        {
          sw.Write('*');
        }
        sw.WriteLine();
      }
      sw.Close();
    }

    private static int Parthossz()
    {
      int meter = 0;
      for (int i = 1; i <= Hosszu; i++)
        for (int j = 1; j <= Szeles; j++)
          if (To[i,j] == 0)
          {
            if (To[i - 1, j] != 0)
              meter++;
            if (To[i + 1, j] != 0)
              meter++;
            if (To[i, j - 1] != 0)
              meter++;
            if (To[i, j + 1] != 0)
              meter++;
          }
      return meter;
    }

    private static void Legmelyebb()
    {
      int mely = 0;
      for (int i = 1; i <= Hosszu; i++)
        for (int j = 1; j <= Szeles; j++)
          if (To[i,j] > mely)
            mely = To[i, j];
      Console.WriteLine($"A tó legnagyobb mélysége: {mely} dm");
      Console.WriteLine("A legmélyebb helyek sor - oszlop koordinátái:");
      for (int i = 1; i <= Hosszu; i++)
        for (int j = 1; j <= Szeles; j++)
          if (To[i, j] == mely)
            Console.Write($"({i}; {j}) ");
      Console.WriteLine();
    }

    private static (int t, double h) Jellemzes()
    {
      int t = 0;
      double h = 0.0;
      for (int i = 1; i <= Hosszu; i++)
        for (int j = 1; j <= Szeles; j++)
          if (To[i,j] != 0)
          {
            t++;
            h += To[i, j];
          }
      h /= t*10;
      return (t, h);
    }

    private static void Beolvas()
    {
      StreamReader sr = new StreamReader("melyseg.txt");
      Hosszu = int.Parse(sr.ReadLine());
      Szeles = int.Parse(sr.ReadLine());
      To = new int[Hosszu + 2, Szeles + 2];
      for (int i = 1; i <= Hosszu; i++)
      {
        string[] sor = sr.ReadLine().Split(' ');
        for (int j = 1; j <= Szeles; j++)
          To[i, j] = int.Parse(sor[j - 1]);
       }
    }
  }
}
